//+------------------------------------------------------------------+
//|                                               LSA_SinLR_v1_3.mq4 |
//|                                         Copyright  2010, Candid |
//|                                         http://candid.110mb.com/ |
//+------------------------------------------------------------------+
//   Close  (High+Low)/2      .
string IndName = "LSA_SinLR_v1_3";

#define pi 3.14159265358979323846
#define MIN_FRAME 120
#define MAX_FRAME 540

//#property indicator_separate_window
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_width1 2
#property indicator_color1 Gold
#property indicator_width2 2
#property indicator_color2 Blue
//----
extern double kPer = 4.0;   //    
extern int LRRank = 1;      //   ,  3-  
extern int FShift = 120;    //   ,      
extern int HShift = 1;      //        
extern double PointFactor = 0.1;  //    , 0.1      
extern bool PriceClose = true; //  false,     HL/2
//----

double INF;
int Rank;
int IntShift;
int BaseSize;
int Frame;
int Step;
double AFreq;

int iRank;
int Ranks[4] = {3,4,5,6};
int RanksThr[4] = {280,1233,5420,23830};
int Steps[4] = {1,4,19,85};
int ir;

double VL[];
double VT[];
int pos;
double AL[],XCL[];
double AT[],XCT[];
double Resid[];

string OName;
int BCol;
int OCol;
int PreBars;

double AppBuf[];
double Price[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
  if(LRRank > 3) LRRank = 3;
  INF = 1.7*MathExp(308);
  PreBars = 0;
  IndicatorShortName(IndName);
  
  

  SetIndexBuffer(0, AppBuf);
  SetIndexStyle(0, DRAW_LINE, EMPTY, 2);
  SetIndexShift(0, FShift);
  SetIndexEmptyValue(0, 0.0);

  SetIndexBuffer(1, Price);
  SetIndexStyle(1, DRAW_LINE, EMPTY, 2);
  SetIndexShift(1, FShift);
  SetIndexEmptyValue(1, 0.0);

  IntShift = MAX_FRAME/4;
  BaseSize = MAX_FRAME-IntShift;

  ArrayResize(Resid,MAX_FRAME);  //    
  
//   
  ArrayResize(AL,6);  //  n*(n+1)
  ArrayResize(XCL,2);  //  n
  ArrayResize(VL,BaseSize*3);  //  BaseSize*(n+1)

//   
  ArrayResize(AT,6);  //  n*(n+1)
  ArrayResize(XCT,2);  //  n
  ArrayResize(VT,BaseSize*3);  //  BaseSize*(n+1)
  
  ObjectCreate("LSA_SinLR_Beg",OBJ_VLINE,0,0,0);
  ObjectSet("LSA_SinLR_Beg",OBJPROP_COLOR,Blue);
  ObjectCreate("LSA_SinLR_OOS",OBJ_VLINE,0,0,0);
  ObjectSet("LSA_SinLR_OOS",OBJPROP_COLOR,Blue);
  ObjectCreate("LSA_SinLR_Fut",OBJ_VLINE,0,0,0);

  ObjectCreate("LSA_SinLR_Names",OBJ_LABEL,0,0,0);
  ObjectSet("LSA_SinLR_Names",OBJPROP_CORNER,3);
  ObjectSet("LSA_SinLR_Names",OBJPROP_XDISTANCE,4);
  ObjectSet("LSA_SinLR_Names",OBJPROP_YDISTANCE,2);
  ObjectSetText("LSA_SinLR_Names","Base OoS",12,"Rockwell Condensed",Blue); 
//----
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |                                                                 |
//+------------------------------------------------------------------+
int deinit() {
  Comment("");
  ObjectDelete("LSA_SinLR_Beg");
  ObjectDelete("LSA_SinLR_OOS");
  ObjectDelete("LSA_SinLR_Fut");

  ObjectDelete("LSA_SinLR_Names");
  for (int i=BCol;i>0;i--) {
    OName = IndName+"_B"+i;
    ObjectDelete(OName);
  } 
  for (i=OCol;i>0;i--) {
    OName = IndName+"_O"+i;
    ObjectDelete(OName);
  } 
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator start function                                  |
//+------------------------------------------------------------------+
int start() { 
  if (PreBars == Bars) return(0);
  PreBars = Bars;

  double Ap;
  double BErr;
  double OErr;
  double Err;
  double SumErr;
  double SumFErr;
  double MinErr;
  int MinErrFrame;
  int i;
  int ind;
  int FPos;
  int LPos;
  int MaxFrame;
  color OColor;

  datetime IndCurTime = ObjectGet("LSA_SinLR_Fut",OBJPROP_TIME1);
  if (IndCurTime > 0) HShift = iBarShift(NULL,0,IndCurTime,false);
  HShift--;
  ObjectSet("LSA_SinLR_Fut",OBJPROP_TIME1,Time[HShift]);

  iRank = LRRank;
  Rank = Ranks[iRank];
  Step = Steps[iRank];

  if (MAX_FRAME*Step+HShift > Bars-1) MaxFrame = (Bars-1-HShift)/Step;
  else MaxFrame = MAX_FRAME;
  MinErr = INF;
  for(Frame = MIN_FRAME; Frame < MaxFrame; Frame++) {
//   
    IntShift = Frame/4;
    BaseSize = Frame-IntShift;
    ind = 0;
//  
    for(i = IntShift; i < Frame; i++) {
     pos = HShift+i*Step;
     VL[ind] = 1.0;
     ind++;
     VL[ind] = pos;
     ind++;
     if (PriceClose) VL[ind] = Close[pos];   
     else VL[ind] = 0.5*(High[pos]+Low[pos]);   
     ind++;
    }  //  for(i = FPos; i < LPos; i++)
//  
   LSA(VL, BaseSize, 2, AL, XCL);
   SumErr = 0.0;
   for(i = 0; i < IntShift; i++) {
     pos = HShift+i*Step;
     if (PriceClose) Err = XCL[0]+XCL[1]*pos - Close[pos];
     else Err = XCL[0]+XCL[1]*pos - 0.5*(High[pos]+Low[pos]);
     SumErr += Err*Err;
   }  //  for(i = HShift; i < FPos; i++)
    if(MinErr > SumErr) {
      MinErr = SumErr;
      MinErrFrame = Frame;
    }
  }  //  for(Frame = MIN_FRAME; Frame <= MAX_FRAME; Frame++)

  Frame = MinErrFrame;
  int SFrame = Frame*Step; 
  IntShift = Frame/4;
  BaseSize = Frame-IntShift;
  ind = 0;
  for(i = IntShift; i < Frame; i++) {
   pos = HShift+i*Step;
   VL[ind] = 1.0;
   ind++;
   VL[ind] = pos;
   ind++;
   if (PriceClose) VL[ind] = Close[pos];   
   else VL[ind] = 0.5*(High[pos]+Low[pos]);   
   ind++;
  }  //  for(i = FPos; i < LPos; i++)
  FPos = pos;
//  
  LSA(VL, BaseSize, 2, AL, XCL);
  LPos = HShift+Frame*Step;
  
  
//   
  iRank--;
  Step = Steps[iRank];
  Rank = Ranks[iRank];
//      
  for (i=0; i<MAX_FRAME; i++) {
    pos = HShift+i*Step;
    Ap = XCL[0]+XCL[1]*pos;
    if (PriceClose) Resid[i] = Close[pos] - Ap;
    else Resid[i] = 0.5*(High[pos]+Low[pos]) - Ap;
  }  //  for(pos = HShift; pos < LPos; pos++)
  MinErr = INF;
  for(Frame = MIN_FRAME; Frame < MAX_FRAME; Frame++) {
//  
//  
    IntShift = Frame/4;
    BaseSize = Frame-IntShift;
    AFreq = 2.0*pi/(BaseSize*Step*kPer);
    ind = 0;
    for(i = IntShift; i < Frame; i++) {
      pos = HShift+i*Step;
      VT[ind] = MathSin(AFreq*pos);
      ind ++;
      VT[ind] = MathCos(AFreq*pos);
      ind ++;
      VT[ind] = Resid[i];   
      ind ++;
    }  //  for(i = IntShift; i < Frame; i++)
//  
    LSA(VT, BaseSize, 2, AT, XCT);
    SumErr = 0.0;
    for(i = 0; i < IntShift; i++) {
      pos = HShift+i*Step;
      Err = XCT[0]*MathSin(AFreq*pos)+XCT[1]*MathCos(AFreq*pos) - Resid[i];
      SumErr += Err*Err;
    }  //  for(i = 0; i < IntShift; i++)
    if(MinErr > SumErr) {
      MinErr = SumErr;
      MinErrFrame = Frame;
    }
  }  //  for(Frame = MIN_FRAME; Frame <= MAX_FRAME; Frame++)

  Frame = MinErrFrame;
  IntShift = Frame/4;
  BaseSize = Frame-IntShift;
  AFreq = 2.0*pi/(BaseSize*Step*kPer);
  ind = 0;
  for(i = IntShift; i < Frame; i++) {
    pos = HShift+i*Step;
    VT[ind] = MathSin(AFreq*pos);
    ind ++;
    VT[ind] = MathCos(AFreq*pos);
    ind ++;
    VT[ind] = Resid[i];   
    ind ++;
  }  //  for(i = IntShift; i < Frame; i++)
//  
  LSA(VT, BaseSize, 2, AT, XCT);

  ObjectSet("LSA_SinLR_Beg",OBJPROP_TIME1,Time[HShift+Frame*Step]);
  ObjectSet("LSA_SinLR_OOS",OBJPROP_TIME1,Time[HShift+IntShift*Step]);
  LPos = HShift+Frame*Step;
  SumFErr = 0.0;
  SumErr = 0.0;
  for(i = -FShift; i < LPos; i++) {
    Ap = XCL[0]+XCL[1]*i;
    Price[i+FShift] = Ap;
    Ap += XCT[0]*MathSin(AFreq*i)+XCT[1]*MathCos(AFreq*i);
    AppBuf[i+FShift] = Ap;
    if (PriceClose) Err = Close[i]-Ap;
    else Err = 0.5*(High[pos]+Low[pos])-Ap;
    if (i >= HShift && i < HShift+IntShift*Step) SumErr += Err*Err;
    if (i >= HShift+IntShift*Step) SumFErr += Err*Err;
  }  //  for(pos = FShift; pos < LPos; pos++)
  BErr = MathSqrt(SumFErr/((Frame-IntShift)*Step))/Point;
  OErr = MathSqrt(SumErr/(IntShift*Step))/Point;

Comment("Rank = ",Rank,", Base Error = ",BErr,", OOS Error = ",OErr,",   : ",SFrame);

  AppBuf[i+FShift] = 0.0;
  Price[i+FShift] = 0.0;

  static int PreBCol = 0;
  BCol = MathRound(BErr*PointFactor);
  if (BCol > PreBCol) {
    for (i=PreBCol+1;i<=BCol;i++) {
      OName = IndName+"_B"+i;
      ObjectCreate(OName,OBJ_LABEL,0,0,0);
      ObjectSet(OName,OBJPROP_CORNER,3);
      ObjectSet(OName,OBJPROP_XDISTANCE,30);
      ObjectSet(OName,OBJPROP_YDISTANCE,5+10*i);
      if (i < 3) OColor = Green;
      else OColor = Red;
      ObjectSetText(OName,"\x6E",12,"Wingdings",OColor); 
    } 
  }
  if (BCol < PreBCol) {
    for (i=PreBCol;i>BCol;i--) {
      OName = IndName+"_B"+i;
      ObjectDelete(OName);
    } 
  }
  PreBCol = BCol;

  static int PreOCol = 0;
  OCol = MathRound(OErr*PointFactor);
  if (OCol > PreOCol) {
    for (i=PreOCol+1;i<=OCol;i++) {
      OName = IndName+"_O"+i;
      ObjectCreate(OName,OBJ_LABEL,0,0,0);
      ObjectSet(OName,OBJPROP_CORNER,3);
      ObjectSet(OName,OBJPROP_XDISTANCE,7);
      ObjectSet(OName,OBJPROP_YDISTANCE,5+10*i);
      if (i < 3) OColor = Green;
      else OColor = Red;
      ObjectSetText(OName,"\x6E",12,"Wingdings",OColor); 
    } 
  }
  if (OCol < PreOCol) {
    for (i=PreOCol;i>OCol;i--) {
      OName = IndName+"_O"+i;
      ObjectDelete(OName);
    } 
  }
  PreOCol = OCol;

  return(0);
}
//+------------------------------------------------------------------+

//   
bool Gauss(double& A[], int N, double& X[]) {
// A -  
// N -   A (N,N+1)
int i,j;   //  
int ind,ind1;   //   
int N1 = N+1;
int NN = N*(N+1);
int k,l,m;
double Max;
double tmp,RA;

  for (i=0;i<N;i++) {
    for (k=0;k<=N;k++) {
//      Print("i=",i,", k=",k,", A[i,k]=",A[k+i*N1]);
    }
  }

//  ,   
  for (i=0;i<N-1;i++) {
//        
    j = i;
    Max = 0.0;
    m=i;
    for (k=i;k<N;k++) {
      ind = j+k*N1;
//   ,        
      if (A[ind]>=0.0) tmp = A[ind];
      else tmp = -A[ind];
      if (tmp > Max) {
        Max  = tmp;
        m = k;  //   
      }
    }  //  for (k=i;k<N;k++)
//     ,     
//      
    if (Max == 0.0) {
      Print("  ",j," ");
      return(false);
    }  //  if (Max == 0)
//      ,         
    k = i*N1;  //     
    if (m != i) {
      l = m*N1;
      for (j=i;j<=N;j++) {
        ind1 = j+k;
        ind = j+l;
        tmp = A[ind];
        A[ind] = A[ind1];
        A[ind1] = tmp;
      }  //  for (j=0;j<=N;j++)
    }  //  if (m != i)
//    
    ind1 = i+k;  //      
    if (A[ind1] != 0.0) RA = 1.0/A[ind1];
    else Print(" 1,   0");
    for (l=i+1;l<N;l++) {
//   
      m = l*N1;  //     
      ind = i+m;
      tmp = A[ind]*RA; 
      A[ind] = 0.0;  
      for (j=i+1;j<=N;j++) {
        ind1 = j+k;
        ind = j+m;
        A[ind] = A[ind] - A[ind1]*tmp;
      }  //  for (j=i+1;j<=N;j++)
    }  //  for (l=i+1;l<N;l++)  
  }  //  for (i=0;i<N;i++)
//     
  for (i=N-1;i>=0;i--) {
    k = i*N1;  //     
    tmp = 0.0;
    for (j=i+1;j<N;j++) {
      ind = j+k;
      tmp = tmp + A[ind]*X[j];
    }  //  for (j=i+1;j<N;j++)
    if (A[i+k] != 0.0) X[i] = (A[N+k]-tmp)/A[i+k]; 
    else Print(" 2,   0");
  }  //  for (i=N-1;i>=0;i--)
  return(true);
}
//+------------------------------------------------------------------+
//                                           |
//+------------------------------------------------------------------+
bool LSA(double& V[], int M, int N, double& A[], double& C[]) {
//  N   M
//      Y    M.
//         V[0..M-1][0..N],
//  Y    N 
//        C  M.
//     A[N][N+1]     
  int i,j,k;   //  
  int ind,ind1;   //   
  int ind3,ind4;   //   
  int N1 = N+1;
  int shj,shi,shk;
//   A,    
  shj = -N1;
  for (j=0;j<N;j++) {
    shj = shj+N1;
//    , ,     
    shk = shj;
    for (k=j+1;k<N;k++) {
      ind = k+shj;
      A[ind] = 0.0;
      shi = -N1;
      for (i=0;i<M;i++) {
        shi = shi+N1;
        ind3 = k+shi;
        ind4 = j+shi;
        A[ind] = A[ind] + V[ind3]*V[ind4];
      }  // for (i=j;i<M;i++)
      shk = shk + N1;
      ind1 = j+shk;
      A[ind1] = A[ind];
    }  //  for (k=0;k<N;k++)  //    
//      
    ind = j+shj;
    A[ind] = 0.0;
    ind1 = N+shj;
    A[ind1] = 0.0;
    shi = -N1;
    for (i=0;i<M;i++) {
      shi = shi+N1;
      ind3 = j+shi;
      ind4 = N+shi;
      A[ind] = A[ind] + V[ind3]*V[ind3];
      A[ind1] = A[ind1] + V[ind4]*V[ind3];
    }  //      
  }  //  for (j=0;j<N;j++)  //   
//        
  Gauss(A, N, C);
  return(true);
}

